config/routes.rb
GSN::Application.routes.draw do

  match 'auth/:provider/callback', to: 'services#create', via: [:get, :post]
  match '/groups/create_group', to: 'groups#create_group', via: [:post]
  match 'auth/failure', to: redirect('/'), via: [:get, :post]
  get '/node_attribute/code_image/:id', to: 'node_attribute#code_image'
  resources :node_types 
  resources :node_attributes
  resources :users do
    member do
     get 'show_other_node'
     post 'create_relation'
    end
    collection do
      post 'show'      
    end
  end
  resources :user_identities
  resources :groups
  resources :group_types
  resources :sessions, only: [:new, :create, :destroy]

  match '/home',    to: 'static_pages#home',    via: 'get'
  match '/signup',  to: 'user_identities#new',       via: 'get'
  match '/signin',  to: 'sessions#new',         via: 'get'  
  match '/signout', to: 'sessions#destroy',     via: Rails.env.test? ? 'get' : 'delete'
  match 'confirm_user/:token', to: 'sessions#confirm_user', via: 'get', as: :confirmation

  root  'static_pages#home'

end

app/models/user_identity.rb
require 'digest'

class UserIdentity 

  include Neo4j::ActiveNode
  include CustomNeo4j
  
  property :id
  property :created_at, type: DateTime
  property :updated_at, type: DateTime
  property :uuid 
  property :uid
  property :email
  property :nickname
  property :provider
  property :country
  property :password
  property :password_digest
  property :remember_token
  property :oauth_token
  property :oauth_expires_at, type: DateTime
  # property :role, type: Boolean, default: false

  property :confirmation_token
  property :confirmed_at, type: DateTime
  property :confirmation_sent_at, type: DateTime
  property :color#, default: "#00FF00"


  property :ns

  # validates :nickname, presence: true, length: { maximum: 50 }
  VALID_EMAIL_REGEX = /\A[\w+\-.]+@[a-z\d\-.]+\.[a-z]+\z/i
  # validates :email, presence: true, format: { with: VALID_EMAIL_REGEX }
  validate :email_uniqueness
  validates :password, length: { minimum: 6 }, if: :is_normal_provider?
  validates_confirmation_of :password,
                          if: lambda { |m| m.password.present? }
  index :email
  index :remember_token
  index :nickname

  before_save { self.email = email.downcase }
  before_save :secure_password
  
  # before_create :create_remember_token
  before_create :set_nickname
  before_create :create_confirmation_token, if: :is_normal_provider?
  # before_create :set_user
  after_create :send_email_confirmation, if: :is_normal_provider?
  after_create :create_user_identities_relation

  # validate :attribute_constraint

  # has_one(:user).from(:identities)
  
  attr_accessor :first_name, :last_name, :email_address

  class << self

    def secure_hash(string)
      Digest::SHA2.hexdigest(string)
    end

    def encrypt_password(email, password)
      secure_hash("#{secure_hash("#{email}-#{password}")}-#{password}")
    end

    def new_random_token
      SecureRandom.urlsafe_base64
    end

    def hash(token)
      Digest::SHA1.hexdigest(token.to_s)
    end    

  end


  def email_uniqueness
    if email.present?
      identity = UserIdentity.find(conditions: {email: email.try(:downcase)})    
      if identity.present? and (identity.email_changed? or new_record?)        
         errors.add(:email, "already exist.")
      end
    end
  end


  def secure_password 
    if (password_changed? or new_record?)
      self.password = UserIdentity.encrypt_password(email, password) 
    end
  end

  # def create_remember_token
  #   # Create the remember token.
  #    self.remember_token = User.hash(User.new_random_token)
  # end

 

  def confirmed?    
     (!Rails.env.test? and is_normal_provider?) ? (confirmed_at.present?) : true
  end

  # def user_id
  # 	@user_id = user_id
  # end  

  def set_nickname    
  	self.nickname = "#{first_name} #{last_name}" if self.nickname.blank?    
  end  

  def create_confirmation_token
    # Create the confirmation token.
     self.confirmation_token = UserIdentity.hash(UserIdentity.new_random_token)
     self.confirmation_sent_at = Time.now.utc
  end

  def send_email_confirmation
    Notification.send_confirmation_email(self).deliver
  end

  def is_normal_provider?
    provider == "normal"
  end

  def identity_provider(provider, uid="", oauth_token="", oauth_expires_at="")
    relation = get_relation(provider)
      
    if relation.blank?
      create_provider_identity(provider, uid, oauth_token, oauth_expires_at)

      if provider=='normal'
        create_confirmation_token
        self.save
        # send_email_confirmation
      end
    else      
      update_provider_identity(relation)
      :error_messsage if provider=='normal'
    end    
  end

  def get_relation(provider)
    provider_relations = self.rels(type: :IS_PROVIDED_BY)     
    relation = nil
    provider_relations.map do |pr|          
      if(pr.get_property("name") == provider)
        relation = pr
      end
    end     
    return relation 
  end

  def create_provider_identity(provider, uid, oauth_token, oauth_expires_at)
    provider_node = Provider.find(conditions: {provider_name: provider})
    
    if provider_node.blank?
      provider_node = Provider.create(provider_name: provider) 
    end
    self.create_rel(:IS_PROVIDED_BY,  provider_node, {uid: uid, name: provider, created_at: Time.now.to_i, updated_at: Time.now.to_i, oauth_token: oauth_token.to_s, oauth_expires_at: oauth_expires_at.to_s})

  end

  def update_provider_identity(relation)
    relation.update_props(updated_at: Time.now.to_s)
  end

  def providers
    rels(type: :provider)
  end
  
  def groups
    rels(dir: :outgoing, type: :groups)
  end 

  def user    
    rels(type: "User#identities")[0]._start_node
  end 

  def create_user_identities_relation
    # social_network = get_social_network.next
    self.create_rel(:_IS_INSTANCE_OF, get_user_identity_model)
    self.create_rel(:_HAS_VERSION, get_version)
    self.create_rel(:_HAS_TRANSLATION, get_translation("user identity", "en-us"), {of: 'name'})
  end

  def get_user_identity_model 
    model_id = Neo4j::Session.query('match (n:Model{name: "user identity"}) RETURN ID(n)').data.flatten.last
    Neo4j::Node.load(model_id)
  end 


  # def set_user
  #   puts "OOOOOOOOOOOOOOOOOOOOOOOOO"
  #   puts user_id    
  # 	user = if user_id.present? 
  # 	         User.find(params[:id]) 
  # 	       else
  # 	         User.create(first_name: first_name, last_name: last_name, country: country)  	  		
  # 	       end
  # 	self.user = user


  def self.user_identity_fields
    # identity_fields = Neo4j::Session.query('match (n:Model{name: "user identity"})-[:_HAS]->(m{complex: "false"})-[:_]->(t)-[:_IS_A]->(s)
    #   return m.name, m.cardinality, s.name, ID(m);').data
    # identity_fields.delete(["remember token", "1", "string", 312])
    # identity_fields.delete(["password digest", "1", "string", 313])
    # identity_fields.delete(["country", "1", "string", 314])
     identity_fields = Neo4j::Session.query('match (n:Model{name: "user identity"})-[r:_HAS]->(m{complex: "false"})-[:_]->(t)-[:_IS_A]->(s) where r.show IS NULL AND  NOT(m.name="country") AND NOT(m.name="password") return m.name, m.cardinality, s.name, ID(m), r.order;').data

    identity_fields
  end

  def attribute_constraint    
    # field_attributes = Neo4j::Session.query('MATCH (n:Model{name: "user identity"})-[:_HAS]->(m) RETURN m.name, m.cardinality, ID(m)')
  
    field_attributes = UserIdentity.user_identity_fields
    validate_field field_attributes
    # binding.pry
  end

end

app/controllers/user_identities_controller.rb
class UserIdentitiesController < ApplicationController
  include CustomNodeRelationship

	before_action :signed_in_user, except: [:new, :create]
  before_action :correct_user,   only: [:edit, :update]
  # before_action :admin_user,     only: :destroy

  def index
   @identities = UserIdentity.all
  end

  def show
    @identity = UserIdentity.find(params[:id])
    @providers = {}
    @providers[:nodes] = []
    @providers[:edges] = []
    @check_node = []
    # random_num = Random.rand(1-6664664646)
     rel_identities = @identity.rels(type: :provider)
     rel_identities.each do |r_identity|
         
       e_node = r_identity.end_node
       e_node_id = r_identity.end_node.neo_id
       s_node = r_identity.start_node 
       s_node_id = r_identity.start_node.neo_id
       edge_properties = r_identity.props
       edge_relation_resource = r_identity.load_resource
       edge_relation = edge_relation_resource.present? ? edge_relation_resource["type"] : ""
       color_prop = r_identity.end_node.props[:color].present? ? r_identity.end_node.props[:color] : '#666'
       unless @check_node.include? e_node_id
         @check_node << e_node_id
         @providers[:nodes] << create_node(node: e_node, relation: edge_relation, label: e_node.labels[0], color: color_prop)
          
       end
       @providers[:edges] << create_edge(source: s_node, target: e_node, relsation: r_identity, color: '#ccc', relation_name: edge_relation)
     end
   
     @providers[:nodes] << create_node(node: @identity, label: @identity.labels[0], color: @identity.props[:color])
     @providers[:edges] << create_edge(source: current_user, target: @identity, relation: @identity.rels(type: 'User#identities')[0], color: '#ccc', relation_name: 'User#identities')
     @providers[:nodes] << create_node(node: current_user, label: current_user.labels[0], color: current_user.props[:color])
   
  end

  def new
    # @identity = UserIdentity.new
     new_identity
  end

  def edit
    @identity = UserIdentity.find(params[:id])
  end

  def update
    @identity = UserIdentity.find(params[:id])
    if @identity.update_attributes(identity_params)
      flash[:success] = "Profile updated"
      redirect_to @identity
    else
      render 'edit'
    end
  end

  def create
    # @identity = UserIdentity.new(identity_params)
    # if @identity.save
    @exist_identity =  UserIdentity.find(conditions: {email: params[:user_identity][:email_address].downcase})   
    # if params[:password]!=params[:password_confirmation]
    #   new_identity
    #   flash[:danger] = "Password not match with confirm password."      
    #   render 'new'
    #   return
    # end 
    # respond_to do |format|
      if @exist_identity.blank?        
        if signed_in?
           @user = current_user
        else    
          @user = User.new(first_name: params[:user_identity][:first_name],
                         last_name: params[:user_identity][:last_name], 
                         country: params[:user_identity][:country],
                         other_languages: params[:user_identity][:other_languages],
                         default_language: params[:user_identity][:default_language],                       
                         ns: "ki"
                     ) 
          # user.create_users_relation                      
        end

        if @user.save
          @identity = UserIdentity.new(country: params[:user_identity][:country], 
            email:  params[:user_identity][:email_address], password: params[:user_identity][:password], 
            password_confirmation: params[:user_identity][:password_confirmation], 
            nickname: "#{params[:user_identity][:first_name]} #{params[:user_identity][:last_name]}", 
            ns: "ki", provider: "normal")

          if @identity.save
            @user.identities << @identity 
            # @identity.user = user
            @identity.identity_provider("normal")
            @success_identity = @identity
            flash[:success] = signed_in? ? "Identity successfully created" : "Please verify your email"        
            # format.html {redirect_to @identity}
            # format.js {render :js => "window.location.href='/users/"+@identity.neo_id+"'"} 
          else
            show_flash_error_messages(@identity)
            new_identity
           # format.html { render 'new' }     
          end
        else
          show_flash_error_messages(@user)     
          new_identity
          # format.html { render 'new' }          
        end
      else
        relation =  @exist_identity.identity_provider("normal")
        
        if relation == :error_messsage
          @identity = @exist_identity
          new_identity
          flash[:danger] = "Identity already created"      
          # format.html { render 'new' }     
        end
      end
    # end
  end

  def destroy
    UserIdentity.find(params[:id]).destroy
    flash[:success] = "Identity deleted."
    redirect_to user_identities_url
  end

  def nodes
    current_user.rels
    # neo = Neography::Rest.new
    # cypher_query =  " START node = node:nodes_index(type='User')"
    # cypher_query << " RETURN ID(node), node"
    # neo.execute_query(cypher_query)["data"].collect{|n| {"id" => n[0]}.merge(n[1]["data"])}
  end  

 def edges
  # neo = Neography::Rest.new
  # cypher_query =  " START source = node:nodes_index(type='User')"
  # cypher_query << " MATCH source -[rel]-> target"
  # cypher_query << " RETURN ID(rel), ID(source), ID(target)"
  # neo.execute_query(cypher_query)["data"].collect{|n| {"id" => n[0], "source" => n[1], "target" => n[2]} }
 end

  private

    def identity_params
      # params.require(:user_identity).permit(:email, :password,
      #                              :password_confirmation, :first_name, :last_name, :country)
      params.permit!
    end

    # Before filters

    def correct_user
      user_id = UserIdentity.find(params[:id]).user.neo_id
      user = User.find(user_id)
      redirect_to(root_url) unless current_user?(user)
    end

    def admin_user
      redirect_to(root_url) unless current_user.admin
    end

    def new_identity
      user_identity_fields = UserIdentity.user_identity_fields
      user_fields = Neo4j::Session.query('match (n:Model{name: "user"})-[r:_HAS]->(m{complex: "false"})-[:_]->(t)-[:_IS_A]->(s) where r.show IS NULL
        return m.name, m.cardinality, s.name, ID(m), r.order;').data

      # user_form_fields = user_fields + user_identity_fields
      # user_form_fields.delete(["remember token", "1", "string"])
      # user_form_fields.delete(["password digest", "1", "string"])
      # user_form_fields << ["password", "1", "string"]
      # user_form_fields << ["password_confirmation", "1", "string"]
      @user_identity_fields = user_identity_fields.uniq.sort_by{|k|k[4]}
      @user_fields = user_fields.uniq.sort_by{|k|k[4]}
    end

  
    
end

app/views/user_identities/_identity.html.erb
<li>
  <%#= gravatar_for user, size: 52 %>
  <%= link_to identity.nickname, identity %>
  <%# if current_user.admin && !current_user?(identity) %>
    | <%#= link_to "delete", user, method: :delete,
                                  data: { confirm: "You sure?" } %>
  <%# end %>
</li>

app/views/user_identities/create.js.erb
<%# binding.pry %>
<% if @success_identity.present? %>
  window.location = "/users/<%= @success_identity.id %>" 
<% else %>
$("#alert_message_div").html("<%= escape_javascript(render(:partial => 'shared/alert_message')) %>")
<% end %>

app/views/user_identities/edit.html.erb
<% provide(:title, "Edit identity") %>
<h1>Update your profile</h1>

<div class="row">
  <div class="span6 offset3">
    <%= form_for(@identity, html: { class: "form-signin auth_form"}) do |f| %>
      <%= render 'shared/error_messages', object: f.object %>      
      <%= f.label :nickname %>
      <%= f.text_field :nickname, class: "form-control"  %>     

      <%= f.label :email %>
      <%= f.text_field :email, class: "form-control"  %>

      <%= f.label :country %>
      <%= f.text_field  :country, class: "form-control"  %>

      <%= f.label :password %>
      <%= f.password_field :password, class: "form-control"  %>

      <%= f.label :password_confirmation, "Confirm Password" %>
      <%= f.password_field :password_confirmation, class: "form-control"  %>

      <%= f.submit "Save changes", class: "btn btn-large btn-primary" %>
    <% end %>

    <%#= gravatar_for @user %>
    
  </div>
</div>

app/views/user_identities/index.html.erb
<% provide(:title, 'All users') %>
<h1>All users</h1>

<ul class="users">
  <% @identities.each do |identity| %>
    <%= render identity %>
  <% end %>
</ul>

app/views/user_identities/new.html.erb
<%# provide(:title, 'Sign up') %>


<div class="row">
  <div class="span6 offset3">
    <%= form_tag user_identities_path, class: "form-signin auth_form", remote: true do |f| %>
      <%#= f.hidden_field :provider, value: "normal" %>
      <%#= render 'shared/error_messages', object: f.object %>
      <% @user_identity_fields.each do |field| %>
        <%= label_tag field[0] %>
        <%= generate_fields(field[0], field[1], field[2]) %>
      <% end %>

      <%= label_tag "Password" %>
      <%= password_field_tag "user_identity[password]", "", autofocus: true, class: "form-control", placeholder: "Password", required: true%>

      <%= label_tag "Password Confirmation" %>
      <%= password_field_tag "user_identity[password_confirmation]", "", autofocus: true, class: "form-control", placeholder: "Password Confirmation", required: true%>       
      <% @user_fields.each do |field| %>
        <%= label_tag field[0] %>
        <%= generate_fields(field[0], field[1], field[2]) %>
      <% end %>  
      <%= submit_tag "Create my account", class: "btn btn-large btn-primary" %>
    <% end %>
  </div>
</div>

app/views/user_identities/show.html.erb
<div class="clear"></div>
<!-- <div class="row">
   <%#= link_to "Groups", groups_path(identity: @identity.uuid ), class: "btn btn-primary remove_overlap"%>
  <aside class="span4">
    <section>
      <h1> <%#= @identity.nickname %> </h1>
      <h1> <%#= @identity.email %> </h1>
    </section>
    <section>
     <div><h3 style="display: inline" >Provider:</h4> <span><%#= @identity.provider %></span></div>
     <div><h3 style="display: inline" >Email:</h4> <%#= @identity.email %></div>
     <div><h3 style="display: inline" >Nickname:</h4> <%#= @identity.nickname %></div>
      <%#= render 'shared/stats' %>
    </section>
  </aside>

  </div> -->

<%= render "shared/graph_template"%>
<%= render "shared/graph_script", parsed_data: @providers %>

 